import { Component, EventEmitter, Input, Output, ViewChild } from '@angular/core';
import { environment } from 'src/environments/environment';
import { Image, ImagesService } from '../services/images.service';
import { ScrollService } from '../services/scroll.service';

@Component({
    selector: 'app-images',
    templateUrl: './images.component.html',
    styleUrls: ['./images.component.scss']
})
export class ImagesComponent {
    @Input() public n = 10;
    @Input() public feedFunc: (n: number, i: number) => Promise<Image[]> = async () => [];

    public ended = false;
    public images: Image[] = [];
    public environment = environment;
    public i = 0;
    private sub: () => void;

    public async next() {
        const res = await this.feedFunc(this.n, this.i);
        if (res.length === 0) {
            this.ended = true;
            this.sub();
            return false;
        }
        else {
            this.images.push(...res);
            this.i++;
        }
        return true;
    }

    public constructor(
        public scroll: ScrollService
    ) {
        this.sub = scroll.endReached.subscribe(() => {
            this.next();
        }).unsubscribe;
    }
}
