import { Component, ViewChild } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { User, UsersService } from '../services/users.service';
import { Image, ImagesService } from '../services/images.service';
import { environment } from 'src/environments/environment';
import { ImagesComponent } from '../images/images.component';

@Component({
  selector: 'app-page-user',
  templateUrl: './page-user.component.html',
  styleUrls: ['./page-user.component.scss']
})
export class PageUserComponent {
    @ViewChild("imgs")
    public imagesEl!: ImagesComponent;
    public user: User = { username: 'loading...' };

    public feed(n: number, i: number) {
        return this.images.userFeed(this.user.username, { n, i });
    }

    public constructor(
        route: ActivatedRoute,
        users: UsersService,
        private images: ImagesService,
    ) {
        route.paramMap.subscribe(async v => {
            this.user = await users.get(v.get('name')!);
            this.imagesEl.next();
        });
    }
}
